//package de.twenty11.skysail.common.converter;
//
//import java.io.IOException;
//import java.util.Iterator;
//import java.util.Map.Entry;
//
//import org.apache.commons.lang.StringUtils;
//import org.codehaus.jackson.JsonNode;
//import org.codehaus.jackson.map.ObjectMapper;
//import org.codehaus.jackson.node.ArrayNode;
//import org.codehaus.jackson.node.IntNode;
//import org.codehaus.jackson.node.ObjectNode;
//import org.codehaus.jackson.node.TextNode;
//import org.restlet.ext.jackson.JacksonConverter;
//import org.restlet.representation.Representation;
//import org.restlet.representation.StringRepresentation;
//import org.restlet.representation.Variant;
//import org.restlet.resource.Resource;
//
//import de.twenty11.skysail.common.responses.Response;
//
//public class BrowserJacksonConverter extends JacksonConverter {
//
//	private ObjectMapper m = new ObjectMapper();
//
//	@Override
//	public Representation toRepresentation(Object source, Variant target,
//			Resource resource) {
//		Representation representation = super.toRepresentation(source, target,
//				resource);
//		try {
//			return new StringRepresentation(
//					jsonToHtml(representation.getText()));
//		} catch (IOException e) {
//			e.printStackTrace();
//		}
//		return representation;
//	}
//
//	public String jsonToHtml(String json) {
//
//		JsonNode rootNode;
//		StringBuffer html = new StringBuffer();
//		try {
//			rootNode = m.readValue(json, JsonNode.class);
//			html = handleNode(rootNode, 1);
//			// m.writeValue(new File("user-modified.json"), rootNode);
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//
//		// StringBuffer sb = new StringBuffer("<!DOCTYPE html>\n")
//		// .append("<html><head><title>BrowserJacksonPresentation</title>\n")
//		// .append("<link rel=\"stylesheet\" type=\"text/css\" href=\"chrome://jsonview/content/default.css\">\n")
//		// .append("<script type=\"text/javascript\" src=\"chrome://jsonview/content/default.js\"></script>")
//		// .append("</head>\n<body>\n").append(json).append("\n</body>\n</html>");
//		StringBuffer sb = new StringBuffer("<div id=\"json\">\n{\n");
//		sb.append("  <ul class=\"obj collapsible\">\n");
//		sb.append(html);
//		sb.append("  </ul>\n");
//		sb.append("}\n</div>");
//		return sb.toString();
//	}
//
//	private StringBuffer handleNode(JsonNode rootNode, int indentation) {
//		StringBuffer html = new StringBuffer();
//
//		if (rootNode instanceof ObjectNode) {
//			Iterator<Entry<String, JsonNode>> fields = rootNode.getFields();
//			while (fields.hasNext()) {
//				Entry<String, JsonNode> next = fields.next();
//				String key = next.getKey();
//				JsonNode value = next.getValue();
//
//				if (value instanceof TextNode) {
//					html = appendTextNode(html, key, value, indentation + 1);
//				} else if (value instanceof ArrayNode) {
//					html = appendArrayNode(html, key, value, indentation + 1);
//				} else {
//					throw new IllegalStateException(
//							"cannot handle node of type "
//									+ value.getClass().getCanonicalName());
//				}
//
//			}
//		} else if (rootNode instanceof ArrayNode) {
//			Iterator<JsonNode> iterator = rootNode.iterator();
//			while (iterator.hasNext()) {
//				JsonNode sub = iterator.next();
//				html.append(indent(indentation + 1)).append("<li>");
//
//				html.append(handleNode(sub, indentation + 1));
//
//				if (iterator.hasNext()) {
//					html.append(",</li>\n");
//				} else {
//					html.append("</li>\n");
//				}
//			}
//		} else if (rootNode instanceof TextNode) {
//			html.append("<span class=\"string\">" + rootNode + "</span>");
//		} else if (rootNode instanceof IntNode) {
//			html.append("<span class=\"num\">" + rootNode + "</span>");
//		} else {
//			throw new IllegalStateException("cannot handle node of type "
//					+ rootNode.getClass().getCanonicalName());
//		}
//
//		return html;
//	}
//
//	private StringBuffer appendArrayNode(StringBuffer html, String key,
//			JsonNode value, int i) {
//		ArrayNode arrayNode = (ArrayNode) value;
//
//		// @formatter:off
//		html.append(indent(i)).append("<li>\n");
//		html.append(indent(i)).append("  <div class=\"collapser\">-</div>\n");
//		html.append(indent(i)).append("  <span class=\"prop\">\n");
//		html.append(indent(i)).append("    <span class=\"q\">\"</span>" + key + "<span class=\"q\">\"</span>\n");
//		html.append(indent(i)).append("  </span>: [\n");
//		html.append(indent(i)).append("  <ul class=\"array collapsible\">\n");
//
//		html.append(handleNode(arrayNode, i + 1));
//
//		html.append(indent(i)).append("  </ul>\n");
//		html.append(indent(i)).append("  ]\n");
//		html.append(indent(i)).append("</li>\n");
//		// @formatter:on
//		
//		return html;
//	}
//
//	private StringBuffer appendTextNode(StringBuffer html, String key,
//			JsonNode value, int i) {
//		
//		// @formatter:off
//		html.append(indent(i)).append("<li>\n");
//		html.append(indent(i)).append("  <span class=\"prop\">\n");
//		html.append(indent(i)).append("    <span class=\"q\">\"</span>" + key + "<span class=\"q\">\"</span>\n");
//		html.append(indent(i)).append("  </span>:\n");
//		html.append(indent(i)).append("  <span class=\"string\">" + value + "</span>\n");
//		
//		//html.append(handleNode(value, i + 1));
//		
//		html.append(indent(i)).append("</li>\n");
//		// @formatter:on
//		
//		return html;
//	}
//
//	@Override
//	public float score(Object source, Variant target, Resource resource) {
//		float result = -1.0F;
//
//		if (source instanceof Response<?>) {
//			result = 1.0F;
//		} else {
//			result = 0.5F;
//		}
//
//		return result;
//	}
//
//	private String indent(int i) {
//		return StringUtils.repeat("  ", i);
//	}
//
// }
